/* c402.c: ********************************************************************}
{* Tma: Nerekurzivn implementace operac nad BVS 
**                                     Implementace: Petr Pikryl, prosinec 1994
**                                           pravy: Petr Pikryl, listopad 1997
**                                                     Petr Pikryl, kvten 1998
**			  	                        Pevod do jazyka C: Martin Tuek, srpen 2005
**                                         pravy: Bohuslav Kena, listopad 2009
**
** S vyuitm dynamickho pidlovn pamti, implementujte NEREKURZIVN
** nsledujc operace nad binrnm vyhledvacm stromem (pedpona BT znamen
** Binary Tree a je u identifiktor uvedena kvli mon kolizi s ostatnmi
** pklady):
**
**     BTInit .......... inicializace stromu
**     BTInsert ........ nerekurzivn vloen novho uzlu do stromu
**     BTPreorder ...... nerekurzivn prchod typu pre-order
**     BTInorder ....... nerekurzivn prchod typu in-order
**     BTPostorder ..... nerekurzivn prchod typu post-order
**     BTDisposeTree ... zru vechny uzly stromu
**
** U vech funkc, kter vyuvaj nkter z prchod stromem, implementujte
** pomocnou funkci pro nalezen nejlevjho uzlu v podstromu.
**
** Pesn definice typ naleznete v souboru c402.h. Uzel stromu je typu tBTNode,
** ukazatel na nj je typu tBTNodePtr. Jeden uzel obsahuje poloku int Cont,
** kter souasn slou jako uiten obsah i jako vyhledvac kl 
** a ukazatele na lev a prav podstrom (LPtr a RPtr).
**
** Pklad slou zejmna k procvien nerekurzivnch zpis algoritm
** nad stromy. Ne zanete tento pklad eit, prostudujte si dkladn
** principy pevodu rekurzivnch algoritm na nerekurzivn. Programovn
** je pedevm inenrsk disciplna, kde optn objevovn Ameriky nem
** msto. Pokud se Vm zd, e by nco lo zapsat optimlnji, promyslete
** si vechny detaily Vaeho een. Povimnte si typickho umstn akc
** pro rzn typy prchod. Zamyslete se nad modifikac eench algoritm
** napklad pro vpoet potu uzl stromu, potu list stromu, vky stromu
** nebo pro vytvoen zrcadlovho obrazu stromu (pouze popehazovn ukazatel
** bez vytven novch uzl a ruen starch).
**
** Pi prchodech stromem pouijte ke zpracovn uzlu funkci BTWorkOut().
** Pro zjednoduen prce mte pedem pipraveny zsobnky pro hodnoty typu
** bool a tBTNodePtr. Pomocnou funkci BTWorkOut ani funkce pro prci
** s pomocnmi zsobnky neupravujte 
**
** Pozor! Je teba sprvn rozliovat, kdy pout dereferenn opertor *
** (typicky pi modifikaci) a kdy budeme pracovat pouze se samotnm ukazatelem 
** (nap. pi vyhledvn). V tomto pkladu vm napov prototypy funkc.
** Pokud pracujeme s ukazatelem na ukazatel, pouijeme dereferenci.
**/

#include "c402.h"
int solved;

void BTWorkOut (tBTNodePtr Ptr)		{
/*   ---------
** Pomocn funkce, kterou budete volat pi prchodech stromem pro zpracovn
** uzlu urenho ukazatelem Ptr. Tuto funkci neupravujte.
**/
			
	if (Ptr==NULL) 
    printf("Chyba: Funkce BTWorkOut byla volna s NULL argumentem!\n");
  else 
    printf("Vpis hodnoty danho uzlu> %d\n",Ptr->Cont);
}
	
/* -------------------------------------------------------------------------- */
/*
** Funkce pro zsobnk hotnot typu tBTNodePtr. Tyto funkce neupravujte.
**/

void SInitP (tStackP *S)  
/*   ------
** Inicializace zsobnku.
**/
{
	S->top = 0;
}	

void SPushP (tStackP *S, tBTNodePtr ptr)
/*   ------
** Vlo hodnotu na vrchol zsobnku.
**/
{ 
                 /* Pi implementaci v poli me dojt k peteen zsobnku. */
  if (S->top==MAXSTACK) 
    printf("Chyba: Dolo k peteen zsobnku s ukazateli!\n");
  else {  
		S->top++;  
		S->a[S->top]=ptr;
	}
}	

tBTNodePtr STopPopP (tStackP *S)
/*         --------
** Odstran prvek z vrcholu zsobnku a souasn vrt jeho hodnotu.
**/
{
                            /* Operace nad przdnm zsobnkem zpsob chybu. */
	if (S->top==0)  {
		printf("Chyba: Dolo k podteen zsobnku s ukazateli!\n");
		return(NULL);	
	}	
	else {
		return (S->a[S->top--]);
	}	
}

bool SEmptyP (tStackP *S)
/*   -------
** Je-li zsobnk przdn, vrt hodnotu true.
**/
{
  return(S->top==0);
}	

/* -------------------------------------------------------------------------- */
/*
** Funkce pro zsobnk hotnot typu bool. Tyto funkce neupravujte.
*/

void SInitB (tStackB *S) {
/*   ------
** Inicializace zsobnku.
**/

	S->top = 0;  
}	

void SPushB (tStackB *S,bool val) {
/*   ------
** Vlo hodnotu na vrchol zsobnku.
**/
                 /* Pi implementaci v poli me dojt k peteen zsobnku. */
	if (S->top==MAXSTACK) 
		printf("Chyba: Dolo k peteen zsobnku pro boolean!\n");
	else {
		S->top++;  
		S->a[S->top]=val;
	}	
}

bool STopPopB (tStackB *S) {
/*   --------
** Odstran prvek z vrcholu zsobnku a souasn vrt jeho hodnotu.
**/
                            /* Operace nad przdnm zsobnkem zpsob chybu. */
	if (S->top==0) {
		printf("Chyba: Dolo k podteen zsobnku pro boolean!\n");
		return(NULL);	
	}	
	else {  
		return(S->a[S->top--]); 
	}	
}

bool SEmptyB (tStackB *S) {
/*   -------
** Je-li zsobnk przdn, vrt hodnotu true.
**/
  return(S->top==0);
}

/* -------------------------------------------------------------------------- */
/*
** Nsleduje jdro domc lohy - funkce, kter mte implementovat. 
*/

void BTInit (tBTNodePtr *RootPtr)	{
/*   ------
** Provede inicializaci binrnho vyhledvacho stromu.
**
** Inicializaci sm programtor volat pouze ped prvnm pouitm binrnho
** stromu, protoe neuvoluje uzly neprzdnho stromu (a ani to dlat neme,
** protoe ped inicializac jsou hodnoty nedefinovan, tedy libovoln).
** Ke zruen binrnho stromu slou procedura BTDisposeTree.
**	
** Vimnte si, e zde se poprv v hlavice objevuje typ ukazatel na ukazatel,	
** proto je teba pi prci s RootPtr pout dereferenn opertor *.
**/
	
	*RootPtr = NULL;
}

void BTInsert (tBTNodePtr *RootPtr, int Content) {
/*   --------
** Vlo do stromu nov uzel s hodnotou Content.
**
** Z pohledu vkldn chpejte vytven strom jako binrn vyhledvac strom,
** kde uzly s hodnotou men ne m otec le v levm podstromu a uzly vt
** le vpravo. Pokud vkldan uzel ji existuje, neprovd se nic (dan hodnota
** se ve stromu me vyskytnout nejve jednou). Pokud se vytv nov uzel,
** vznik vdy jako list stromu. Funkci implementujte nerekurzivn.
**/
	
	tBTNodePtr ptr_na_otce;	//ukazatel na otce
	tBTNodePtr pom_ptr;  	//pomocny ukazatel, inicializace na koren

	if ( *RootPtr != NULL )
	{//pokud strom neni prazdny
		pom_ptr = *RootPtr;

		do
		{//prochazime cely strom dokud nenalezneme pozadovanou pozici

			if( (pom_ptr->Cont) < Content )
			{//pokud je vkladana hodnota vetsi jdeme vpravo
				ptr_na_otce = pom_ptr;
				pom_ptr = pom_ptr->RPtr;
			}
			else if ( (pom_ptr->Cont) > Content )
			{//pokud je vkladana hodnota mensi jdeme vlevo
				ptr_na_otce = pom_ptr;
				pom_ptr = pom_ptr->LPtr;
			}
			else if ( (pom_ptr->Cont) == Content )
				return; //neprovadi se nic
		}while( pom_ptr != NULL );

		pom_ptr = malloc(sizeof(struct tBTNode));//alokace pro novy uzel

		if ( pom_ptr == NULL )
			return;

		pom_ptr->LPtr = NULL;	//ukazatel neukazuje nikam (nema syna)
		pom_ptr->RPtr = NULL;	//ukazatel neukazuje nikam (nema syna)
		pom_ptr->Cont = Content;//zapis obsahu

		if ( (ptr_na_otce->Cont) > Content )
			ptr_na_otce->LPtr = pom_ptr;//navazani na uzel zleva
		else
			ptr_na_otce->RPtr = pom_ptr;//navazani na uzel zprava

	}
	else
	{//pokud je strom prazdny
		pom_ptr = malloc(sizeof(struct tBTNode));//alokace pro novy uzel

		if ( pom_ptr == NULL )
			return;

		pom_ptr->LPtr = NULL;	//ukazatel neukazuje nikam (nema syna)
		pom_ptr->RPtr = NULL;	//ukazatel neukazuje nikam (nema syna)
		pom_ptr->Cont = Content;//zapis obsahu
		(*RootPtr) = pom_ptr;	//prepsani korene
	}

}

/*                                  PREORDER                                  */

void Leftmost_Preorder (tBTNodePtr ptr, tStackP *Stack)	{
/*   -----------------
** Jde po lev vtvi podstromu, dokud nenaraz na jeho nejlevj uzel.
**
** Pi prchodu Preorder navtven uzly zpracujeme volnm funkce BTWorkOut()
** a ukazatele na n is ulome do zsobnku.
**/

	while( ptr != NULL )  
	{//jdeme po leve vetvi, dokud nejsme na nejlevejsim uzlu
		SPushP(Stack, ptr); //pushneme ukazatel do stacku
		BTWorkOut(ptr);		//zpracovani uzlu
		ptr = ptr->LPtr;	//posun po leve vetvi na dalsi uzel
	}
}

void BTPreorder (tBTNodePtr RootPtr)	{
/*   ----------
** Prchod stromem typu preorder implementovan nerekurzivn s vyuitm funkce
** Leftmost_Preorder a zsobnku ukazatel. Zpracovn jednoho uzlu stromu
** realizujte jako voln funkce BTWorkOut(). 
**/

	tStackP 	Stack;	//pomocny zasobnik ukazatelu
	tBTNodePtr 	ptr;	//pomocny ukazatel

	SInitP(&Stack);	//inicializace zasobniku
	ptr = RootPtr;

	Leftmost_Preorder(ptr, &Stack);	//zpracuje leve uzly

	while( !SEmptyP(&Stack) )
	{//dokud jsme neprosli vsechny uzly

		ptr = STopPopP(&Stack);	//precteni a odebrani ze zasobniku
		Leftmost_Preorder(ptr->RPtr, &Stack);	//zpracuje levou diagonalu praveho uzlu
	}
	
}


/*                                  INORDER                                   */ 

void Leftmost_Inorder(tBTNodePtr ptr, tStackP *Stack)		{
/*   ----------------
** Jde po lev vtvi podstromu, dokud nenaraz na jeho nejlevj uzel.
**
** Pi prchodu Inorder ukldme ukazatele na vechny navtven uzly do
** zsobnku. 
**/

	while( ptr != NULL )
	{//jdeme po leve vetvi, dokud nejsme na nejlevejsim uzlu
		SPushP(Stack, ptr);	//pushneme ukazatel do stacku
		ptr = ptr->LPtr;	//posun na dalsi levy uzel
	}

}

void BTInorder (tBTNodePtr RootPtr)	{
/*   ---------
** Prchod stromem typu inorder implementovan nerekurzivn s vyuitm funkce
** Leftmost_Inorder a zsobnku ukazatel. Zpracovn jednoho uzlu stromu
** realizujte jako voln funkce BTWorkOut(). 
**/
	tStackP stack;  //pomocny zasobnik ukazatelu
	tBTNodePtr ptr; //pomocny ukazatel na uzel

	SInitP(&stack);
	ptr = RootPtr;

	Leftmost_Inorder(ptr, &stack);	//zpracuje leve uzly

	while( !SEmptyP(&stack) )
	{//dokud jsme neprosli vsechny uzly

		ptr = STopPopP(&stack);	//precteni a odebrani ze zasobniku
		BTWorkOut(ptr);  //zpracovani uzlu
		Leftmost_Inorder(ptr->RPtr, &stack);	//zpracuje levou diagonalu praveho uzlu
	
	}	
}

/*                                 POSTORDER                                  */ 

void Leftmost_Postorder (tBTNodePtr ptr, tStackP *StackP, tStackB *StackB) {
/*           --------
** Jde po lev vtvi podstromu, dokud nenaraz na jeho nejlevj uzel.
**
** Pi prchodu Postorder ukldme ukazatele na navtven uzly do zsobnku
** a souasn do zsobnku bool hodnot ukldme informaci, zda byl uzel
** navtven poprv a e se tedy jet nem zpracovvat. 
**/
	while( ptr != NULL )
	{//jdeme po leve vetvi, dokud nejsme na nejlevejsim uzlu

		SPushP(StackP, ptr);	//pushneme ukazatel do stacku
		SPushB(StackB, false);	//na vrchol zasobniku vlozime false
		ptr = ptr->LPtr;		//posun na dalsi levy uzel
	}
}

void BTPostorder (tBTNodePtr RootPtr)	{
/*           -----------
** Prchod stromem typu postorder implementovan nerekurzivn s vyuitm funkce
** Leftmost_Postorder, zsobnku ukazatel a zsobnku hotdnot typu bool.
** Zpracovn jednoho uzlu stromu realizujte jako voln funkce BTWorkOut(). 
**/
	tStackP stackP;  //pomocny zasobnik ukazatelu
	tStackB stackB;  //pomocny bool-zasobnik
	tBTNodePtr ptr;	//pomocny ukazatel na uzel

	SInitP(&stackP);
	SInitB(&stackB);

	ptr = RootPtr;	//ulozime si ukazatel
	Leftmost_Postorder(ptr, &stackP, &stackB);

	while( !SEmptyP(&stackP) )
	{//dokud neprojdeme vsechny uzly

		ptr = STopPopP(&stackP);	//precteni a odebrani ze zasobniku
		SPushP(&stackP, ptr);		//pushneme ukazatel na zasobnik

		if( STopPopB(&stackB) == false )	
		{//prichazime zleva	
			SPushB(&stackB, true);
			ptr = ptr->RPtr;
			Leftmost_Postorder(ptr, &stackP, &stackB);	//zpracovani leve diagonaly praveho uzlzu
		}
		else
		{//prichazime zprava
			STopPopP(&stackP);//odebereme ze zasobniku a zpracujeme uzel
			BTWorkOut(ptr);
		}
	}

}


void BTDisposeTree (tBTNodePtr *RootPtr)	{
/*   -------------
** Zru vechny uzly stromu a korektn uvoln jimi zabranou pam.
**
** Funkci implementujte nerekurzivn s vyuitm zsobnku ukazatel.
**/
	tStackP stackP;  //pomocny zasobnik ukazatelu
	tBTNodePtr ptr;	//pomocny ukazatel na uzel

	if((*RootPtr) != NULL)
	{//strom nesmi byt prazdny, jinak se nic nedeje

		SInitP(&stackP);

		do
		{
			if( (*RootPtr) != NULL )  
			{//koren stromu existuje

				if((*RootPtr)->RPtr != NULL)
					SPushP(&stackP, (*RootPtr)->RPtr);  // zapsani uzlu do zasobniku

				ptr = (*RootPtr);
				(*RootPtr) = (*RootPtr)->LPtr;  // posun na dalsi uzel
				free(ptr);  // odstraneni uzly
			}
			else  
			{//koren stromu uz je odstranen
				if( !SEmptyP(&stackP) )
					(*RootPtr) = STopPopP(&stackP);
			}
		}while( ((*RootPtr) != NULL) || (!SEmptyP(&stackP)) );
	}
}

/* konec c402.c */

