
/* Hlavikov soubor pro c402.c - nerekurzvn implementace operac nad BVS
obsahuje jednak nutn knihovny a extern promnn, ale rovn definici datovch
typ, se ktermi se pracuje v pslunch lohch. Nemodifikovat! */

/* ********************** SOUBOR S HLAVIKOU ********************** */
/* ********************** ------------------ ********************** */

/*  Pedmt: Algoritmy (IAL) - FIT (Fakulta Informanch Technologi)
    Hlavika pro soubor: c402.c
    Vytvoil: Martin Tuek, z 2005
    Upravil: Bohuslav Kena, listopad 2009                           */
/* ***************************************************************** */

#include<stdio.h>
#include<stdlib.h>
#include<stdarg.h>
#include<stdbool.h>

#define FALSE 0
#define TRUE 1
#define MAXSTACK 30                      /* maximln poet prvk v zsobnku */

extern int solved; 			                  /* indikace, zda byla funkce eena */

typedef struct tBTNode	{                                      /* uzel stromu */
    int Cont;                                         /* uiten obsah uzlu  */
    struct tBTNode * LPtr;                                  /* lev podstrom  */
    struct tBTNode * RPtr; 	  	                            /* prav podstrom */
} *tBTNodePtr;                                     /* ukazatel na uzel stromu */

/* pomocn zsobnky */
typedef struct	{                          /* zsobnk hodnot typu tBTNodePtr */
    tBTNodePtr a[MAXSTACK];
    int top;
} tStackP;

typedef struct {                                 /* zsobnk hodnot typu bool */
    bool a[MAXSTACK];
    int top;
} tStackB;

/***prototypes***/
void BTInit (tBTNodePtr * );
void BTInsert (tBTNodePtr *, int );

void Leftmost_Preorder(tBTNodePtr, tStackP *);
void BTPreorder(tBTNodePtr );

void Leftmost_Inorder(tBTNodePtr, tStackP *);
void BTInorder(tBTNodePtr );

void Leftmost_Postorder(tBTNodePtr, tStackP *, tStackB *);
void BTPostorder(tBTNodePtr );

void BTDisposeTree(tBTNodePtr *);
/********end of prototypes******/

/* konec c402.h */
